#ifndef MASTER_H
#define MASTER_H

/**
 * @file master.h
 * @brief Defines master task's data structures and master functionality.
 */

#include <stdbool.h>

#include <unistd.h>
#include <fcntl.h>

#include <mapreduce/mapreduce.h>
#include <mapreduce/partitions.h>

struct master_data {
	struct mapper_descriptor* mappers;
	struct reducer_descriptor* reducers;
	size_t mappers_num;
	size_t reducers_num;
};

struct mapper_descriptor {
	pid_t pid;
	char* part_filename;
	char* intermediate_filename;
	bool completed;
};

struct reducer_descriptor {
	pid_t pid;
	char* tasks_filename;
	int tasks_fd;
	int tasks_sem;
	bool completed;
};


// Main function of Master process.
bool master_task(const struct mapreduce_specification* spec,
		 struct mapreduce_error* err);

#endif // MASTER_H
