/**
 * @file CrashTest.hpp
 * @brief File contains declarations of CrashTest test class..
 */

#ifndef CRASHTEST_HPP
#define CRASHTEST_HPP

#include <mapreduce/mapreduce.h>
#include <mapreduce/tests/AbstractTest.hpp>
#include <mapreduce/tests/CommonUtils.hpp>

/**
 * Map reduce test project namespace.
 */
namespace MapReduceCrashTest
{
	/**
	 * Class represents MapReduce library use test case - it is used to run test
	 * which checks behaviour of library in specific cases.
	 */
	class CrashTest : public AbstractTest
	{
	public:
	  CrashTest();
	  void runTest();
	private:
	  void null_map_test();
	  void null_reduce_test();
	  void empty_input_output_test();
	  void fail_map_test();
	  void fail_reduce_test();

	  const char* inputs;
	  const char* outputs;
	};
}

#endif // CRASHTEST_HPP
