/**
 * @file ImageTest.hpp
 * @brief File contains declarations of ImageTest test class.
 */

#ifndef IMAGETEST_HPP
#define IMAGETEST_HPP

#include <mapreduce/mapreduce.h>
#include <mapreduce/tests/AbstractTest.hpp>
#include <mapreduce/tests/CommonUtils.hpp>

/**
 * Map reduce test project namespace.
 */
namespace MapReduceImageTest
{
	/**
	 * Class represents MapReduce library use test case - it is used to run test which answer if
	 * created bitmap are greyscale or not. Random test. 
	 */
	class ImageTest : public AbstractTest
	{
	private:
		const char* inputs[20];
		const char* outputs[20];
		bool properResult;

		void prepareTest();
	public:
		ImageTest();
		~ImageTest();

		void runTest();
	};
}
#endif // IMAGETEST_HPP

