/**
 * @file PatternSearch.hpp
 * @brief File contains declarations of PatternSearch test class.
 */

#ifndef PATTERNSEARCH_HPP
#define PATTERNSEARCH_HPP

#include <mapreduce/mapreduce.h>
#include <mapreduce/tests/AbstractTest.hpp>
#include <mapreduce/tests/CommonUtils.hpp>

#include <stdlib.h>

/**
 * Map reduce test project namespace.
 */
namespace MapReduceTest
{
	/**
	 * Class represents MapReduce library use test case - it is used to run test which count appearance of
	 * defined pattern like some letter/word.
	 */
	class PatternSearch : public AbstractTest
	{
	private:
		struct mapreduce_specification spec;
		struct mapreduce_error error;

		void prepareTest();
		const char** inputs;
		const char* outputs[2];
		size_t inputsNum;
		int patternAmount;
	
	public:
		PatternSearch(int argc,const char** argv);
		~PatternSearch();

		void runTest();
	};

}
#endif	//PATTERNSEARCH_HPP

