/**
 * @file intput_reader.c
 * @brief Defines functions for mapreduce_input_reader structure.
 */

#include <iso646.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <mapreduce/input_reader.h>

bool
mapreduce_read_input(struct mapreduce_input_reader* const in_r,
		     void* const data, size_t* const size)
{
	assert(in_r not_eq NULL);
	assert(data not_eq NULL);
	assert(size not_eq NULL);
	const ssize_t read_size = read(in_r->fd, data, *size);
	*size = (read_size == -1) ? 0 : read_size;
	return read_size not_eq -1;
}
