/**
 * @file intermediate_reader.c
 * @brief Defines functions for mapreduce_intermediate_reader structure.
 */

#include <iso646.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <mapreduce/intermediate_reader.h>

bool
mapreduce_read_intermediate(struct mapreduce_intermediate_reader* const im_r,
			    void* const data, size_t* const size)
{
	assert(im_r not_eq NULL);
	assert(data not_eq NULL);
	assert(size not_eq NULL);
	*size = ((*size) > im_r->partition_size) ? im_r->partition_size : *size;
	const ssize_t read_size = read(im_r->fd, data, *size);
	*size = (read_size == -1) ? 0 : read_size;
	return read_size not_eq -1;
}
