/**
 * @file intermediate_writer.c
 * @brief Defines functions for mapreduce_intermediate_writer structure.
 */

#include <iso646.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <mapreduce/intermediate_writer.h>

bool
mapreduce_write_part(struct mapreduce_intermediate_writer* const im_w,
		     const void* const data, size_t* const size,
		     const size_t part_num)
{
	assert(im_w not_eq NULL);
	assert(data not_eq NULL);
	assert(size not_eq NULL);
	const off_t offset = lseek(im_w->fd, 0, SEEK_CUR);
	const ssize_t size_write = write(im_w->fd, data, *size);
	*size = (size_write == -1) ? 0 : size_write;
	im_w->parts.parts[part_num].offset = offset;
	im_w->parts.parts[part_num].size = *size;
	return size_write not_eq -1;
}

