/**
 * @file mapreduce.c
 * @brief Defines main mapreduce function.
 */

#include <iso646.h>
#include <assert.h>

#include <unistd.h>
#include <sys/wait.h>

#include <mapreduce/mapreduce.h>
#include <mapreduce/master.h>

bool
mapreduce(const struct mapreduce_specification* const spec,
          struct mapreduce_error* const err)
{
        assert(spec not_eq NULL);
        assert(err not_eq NULL);
        err->code = MAPREDUCE_ERROR_NONE;
        const pid_t master = fork();
        if (master not_eq 0) {
                int stat_val = 0;
                waitpid(master, &stat_val, 0);
                err->code = WEXITSTATUS(stat_val);
        } else {
                master_task(spec, err);
                exit(err->code);
        }
        return err->code == MAPREDUCE_ERROR_NONE;
}
