/**
 * @file output_writer.c
 * @brief Defines functions for mapreduce_output_writer structure.
 */

#include <iso646.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <mapreduce/output_writer.h>

bool
mapreduce_write_out(struct mapreduce_output_writer* const out_w,
		    const void* const data, size_t* const size)
{
	assert(out_w not_eq NULL);
	assert(data not_eq NULL);
	assert(size not_eq NULL);
	const ssize_t size_write = write(out_w->fd, data, *size);
	*size = (size_write == -1) ? 0 : size_write;
	return size_write not_eq -1;
}
