/**
 * @file partitions.c
 * @brief Defines functions for partitions structure.
 */

#include <iso646.h>
#include <assert.h>
#include <stdlib.h>

#include <mapreduce/partitions.h>

struct partitions
partitions_init(const size_t parts_num)
{
	const struct partitions init = {
		.parts = calloc(parts_num, sizeof init.parts[0]),
		.parts_num = parts_num
	};
	assert(init.parts not_eq NULL);
	return init;
}

void partitions_destroy(struct partitions* const destroyed)
{
	assert(destroyed not_eq NULL);
	free(destroyed->parts);
	destroyed->parts = NULL;
}


