/**
 * @file ImageTest.hpp
 * @brief File contains declarations of ImageTest test class.
 */

#ifndef IMAGETEST_HPP
#define IMAGETEST_HPP

#include <mapreduce/mapreduce.h>

#include <sstream>

#include "CommonUtils.hpp"

/**
 * Map reduce test project namespace.
 */
namespace MapReduceImageTest
{
	/**
	 * Class represents MapReduce library use test case - it is used to run test which answer if
	 * created bitmap are greyscale or not. Random test. 
	 */
	class ImageTest
	{
	private:
		struct mapreduce_specification spec;
		struct mapreduce_error error;

		bool properResult;

		void prepareTest();
		const char* inputs[100];
		const char* outputs[20];

	public:
		ImageTest();
		~ImageTest();

		void runTest();
	};
}
#endif // IMAGETEST_HPP

