/**
 * @file main.cpp
 * @brief File contains entry point of MapReduce testing application.
 */

#include <mapreduce/tests/LibraryTest.hpp>
#include <mapreduce/tests/CrashTest.hpp>
#include <mapreduce/tests/PatternSearch.hpp>
#include <mapreduce/tests/ImageTest.hpp>

using namespace std;
using namespace MapReduceCrashTest;
using namespace MapReduceTest;
using namespace MapReduceImageTest;

/**
 * Entry point of application.
 */
int main(int argc, const char** argv)
{
        cout << "Library Unit tests" << endl;

        LibraryTest* libTest = new LibraryTest();
	libTest->runTest();
        delete libTest;

        cout << "Library use test - crash test" << endl;

        CrashTest* crashTest = new CrashTest();
	crashTest->runTest();
        delete crashTest;

	if(argc >= 4)
	{
		cout << "Library use test - PatternSearch " << endl;
	        PatternSearch* patternTest = new PatternSearch(argc,argv);
	        patternTest->runTest();
	        delete patternTest;
	}
	else
	{
		cout << "Library use test - ImageTest " << endl;
		ImageTest* imageTest = new ImageTest();
		imageTest->runTest();
		delete imageTest;
	}
        return 0;
}



